Bug 65344 - kashida should not be used with ligatures on justified Arabic text
Summary: kashida should not be used with ligatures on justified Arabic text
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: graphics stack (show other bugs)
Version:
(earliest affected)
4.0.4.1 rc
Hardware: Other All
: medium normal
Assignee: Ahmad Harthi
QA Contact:
URL:
Whiteboard: target:5.3.0
Keywords:
Depends on: HarfBuzz
Blocks: RTL-CTL
  Show dependency treegraph
 
Reported: 2013-06-04 11:36 UTC by Ahmad Harthi
Modified: 2016-11-08 11:58 UTC (History)
2 users (show)

See Also:
Crash report or crash signature:


Attachments
Kashida used with Fhe + Yeh ligature (98.68 KB, image/png)
2013-06-04 11:36 UTC, Ahmad Harthi
Details
test odt (8.67 KB, application/vnd.oasis.opendocument.text)
2016-11-07 19:39 UTC, Yousuf Philips (jay)
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Ahmad Harthi 2013-06-04 11:36:21 UTC
Created attachment 80287 [details]
Kashida used with Fhe + Yeh ligature

With some fonts, like "Simplified Naskh" there are some kashidas added to ligatures like "Feh + Yeh (في)".
Comment 1 Yousuf Philips (jay) 2014-11-07 14:13:59 UTC
Cant seem to find Simplified Naskh font anywhere? Any other arabic fonts that this happen in that i can find in the ubuntu repos.
Comment 2 QA Administrators 2015-05-06 14:15:01 UTC Comment hidden (obsolete)
Comment 3 QA Administrators 2015-06-08 14:26:37 UTC Comment hidden (obsolete)
Comment 4 Khaled Hosny 2015-06-08 22:00:12 UTC
This issue have not been fixed, and you can try it with fonts like Scheherazade or Lateef.
Comment 5 QA Administrators 2016-09-20 10:01:46 UTC Comment hidden (obsolete)
Comment 6 Khaled Hosny 2016-09-21 07:45:26 UTC
Still an issue, might be fixed with bug 89870.
Comment 7 Khaled Hosny 2016-11-06 19:14:36 UTC
I think the issue he is not ligatures, as في in this font is two separate glyphs that are designed to match each other, AKA contextual alternates, (it is the same effect as ligatures but done in a different way).

Kashida insertion inside ligatures is already fixed as part of bug 89870, but disallowing ligatures between contextual alternates is harder is there is no simple way to identify them and it might be possiple that inserting kashida between them is OK.

But I think the real issue here is that, there should never be an automatic kashida before a final ي, so inserting kashida here is wrong whether there is a ligature or not.
Comment 8 Commit Notification 2016-11-06 20:35:35 UTC
Khaled Hosny committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=7fdb418aea11a4e1f09a04c02d125880925272aa

tdf#65344: Don’t put Kashida before any final char

It will be available in 5.3.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 9 Yousuf Philips (jay) 2016-11-07 19:39:00 UTC
Created attachment 128552 [details]
test odt

Using the attached test document, i couldnt see any difference using Lateef or Scheherazade before and after the fix with harfbuzz on or off.

Version: 5.3.0.0.alpha1+ [after fix]
Build ID: 11cab8aba359c655a75791ddbc0f2ffeae8ce206

Version: 5.3.0.0.alpha1+ [before fix]
Build ID: 4ea62fe8a1194bca3bee5048832456c3559dcb8e

Also couldnt repo it with older versions of LO.

Version: 5.1.5.2
Build ID: 7a864d8825610a8c07cfc3bc01dd4fce6a9447e5

Version: 5.0.6.3
Build ID: 490fc03b25318460cfc54456516ea2519c11d1aa
Comment 10 Khaled Hosny 2016-11-07 19:47:32 UTC
(In reply to Yousuf Philips (jay) from comment #9)
> Created attachment 128552 [details]
> test odt
> 
> Using the attached test document, i couldnt see any difference using Lateef
> or Scheherazade before and after the fix with harfbuzz on or off.

Try the document from attachment 44464 [details] and the font from attachment 44465 [details], the choice of layout engine makes no difference here (it would make difference though in fonts that actually have ligatures, like Traditional Arabic).
Comment 11 Yousuf Philips (jay) 2016-11-08 11:58:13 UTC
(In reply to Khaled Hosny from comment #10)
> Try the document from attachment 44464 [details] and the font from
> attachment 44465 [details], the choice of layout engine makes no difference
> here (it would make difference though in fonts that actually have ligatures,
> like Traditional Arabic).

Yes fixed now. :D